"Filed out from Dolphin Smalltalk 99 release 3.0"!

Object subclass: #Describable
	instanceVariableNames: 'longDescription shortDescription shortNounPhrase longNounPhrase article longDescriptionSeen plural'
	classVariableNames: 'RandomGenerator'
	poolDictionaries: ''!

Describable class instanceVariableNames: ''!

Describable comment: 'Something which has a description.'!

Describable guid: (GUID fromString: '{B1FE94A3-54A3-11D3-8268-00001D19F5C2}')!

!Describable categoriesForClass!Adventure! !

!Describable methodsFor!

article
	article isNil
		ifTrue: [ ^self generateArticle ]
		ifFalse: [ ^article ]
!

article: anObject
	"Set the value of the receiver's instance variable article to anObject.
	This method was automatically generated, but may be modified."

	article := anObject
!

basicDescription
	"Answers the long description if it has not been seen before; otherwise answers
	the short description"

	self longDescriptionSeen
		ifTrue: [ ^self shortDescription ]
		ifFalse: [ self longDescriptionSeen: true.
			     ^self longDescription ]!

basicLongDescription
	^longDescription!

basicLongNounPhrase
	^longNounPhrase!

basicShortDescription
	^shortDescription!

basicShortNounPhrase
	^shortNounPhrase!

description
	^self basicDescription
!

generateArticle
	"Private"
	self longDescriptionSeen
		ifFalse: [ (longNounPhrase at: 1) isVowel ifTrue: [ ^'an' ] ifFalse: [ ^'a' ] ]
		ifTrue: [ (shortNounPhrase at: 1) isVowel ifTrue: [ ^'an' ] ifFalse: [ ^'a' ] ]!

initialize
	self
		longDescriptionSeen: false;
		plural: false!

inventoryDescription2ndPerson
	^'have ', self article, ' ', self nounPhrase!

inventoryDescription3dPerson
	self plural
		ifTrue: [ ^'are ', self article, ' ', self nounPhrase ]
		ifFalse: [ ^'is ', self article, ' ', self nounPhrase ]!

longDescription
	self longNounPhrase notNil
		ifTrue: [ ^(self article size > 0 ifTrue: [ self article, ' '] ifFalse: [ '' ]), self longNounPhrase ]
		ifFalse: [ ^longDescription ]!

longDescription: anObject
	"Set the value of the receiver's instance variable longDescription to anObject.
	This method was automatically generated, but may be modified."

	longDescription := anObject.
	self basicShortDescription isNil ifTrue: [ self shortDescription: anObject ]!

longDescriptionSeen
	"Answer the value of the receiver's instance variable longDescriptionSeen.
	This method was automatically generated, but may be modified."

	^longDescriptionSeen!

longDescriptionSeen: aBoolean
	"Set the value of the receiver's instance variable longDescriptionSeen to anObject.
	This method was automatically generated, but may be modified."

	longDescriptionSeen := aBoolean!

longNounPhrase
	"Answer the value of the receiver's instance variable longNounPhrase.
	This method was automatically generated, but may be modified."

	^longNounPhrase!

longNounPhrase: anObject
	"Set the value of the receiver's instance variable longNounPhrase to anObject.
	This method was automatically generated, but may be modified."

	longNounPhrase := anObject.
	self basicShortNounPhrase isNil ifTrue: [ self shortNounPhrase: anObject ]!

nounPhrase
	self longDescriptionSeen
		ifTrue: [ ^self shortNounPhrase ]
		ifFalse: [ self longDescriptionSeen: true. ^self longNounPhrase ]!

plural
	"Answer the value of the receiver's instance variable plural.
	This method was automatically generated, but may be modified."

	^plural!

plural: anObject
	"Set the value of the receiver's instance variable plural to anObject.
	This method was automatically generated, but may be modified."

	plural := anObject!

points
	^0!

randomGenerator
	^self class randomGenerator!

shortDescription
	self shortNounPhrase notNil
		ifTrue: [ ^self article, ' ', self shortNounPhrase ]
		ifFalse: [ ^shortDescription ]!

shortDescription: anObject
	"Set the value of the receiver's instance variable shortDescription to anObject.
	This method was automatically generated, but may be modified."

	shortDescription := anObject.
	self basicLongDescription isNil ifTrue: [ self longDescription: anObject ]!

shortNounPhrase
	"Answer the value of the receiver's instance variable shortNounPhrase.
	This method was automatically generated, but may be modified."

	^shortNounPhrase!

shortNounPhrase: anObject
	"Set the value of the receiver's instance variable shortNounPhrase to anObject.
	This method was automatically generated, but may be modified."

	shortNounPhrase := anObject.
	self basicLongNounPhrase isNil ifTrue: [ self longNounPhrase: anObject ]! !

!Describable categoriesFor: #article!*-unclassified!public! !
!Describable categoriesFor: #article:!*-unclassified!public! !
!Describable categoriesFor: #basicDescription!*-unclassified!public! !
!Describable categoriesFor: #basicLongDescription!*-unclassified!public! !
!Describable categoriesFor: #basicLongNounPhrase!*-unclassified!public! !
!Describable categoriesFor: #basicShortDescription!*-unclassified!public! !
!Describable categoriesFor: #basicShortNounPhrase!*-unclassified!public! !
!Describable categoriesFor: #description!*-unclassified!public! !
!Describable categoriesFor: #generateArticle!*-unclassified!public! !
!Describable categoriesFor: #initialize!*-unclassified!public! !
!Describable categoriesFor: #inventoryDescription2ndPerson!*-unclassified!public! !
!Describable categoriesFor: #inventoryDescription3dPerson!*-unclassified!public! !
!Describable categoriesFor: #longDescription!accessing!public! !
!Describable categoriesFor: #longDescription:!accessing!public! !
!Describable categoriesFor: #longDescriptionSeen!accessing!public! !
!Describable categoriesFor: #longDescriptionSeen:!accessing!public! !
!Describable categoriesFor: #longNounPhrase!accessing!public! !
!Describable categoriesFor: #longNounPhrase:!accessing!public! !
!Describable categoriesFor: #nounPhrase!*-unclassified!public! !
!Describable categoriesFor: #plural!accessing!public! !
!Describable categoriesFor: #plural:!accessing!public! !
!Describable categoriesFor: #points!*-unclassified!public! !
!Describable categoriesFor: #randomGenerator!*-unclassified!public! !
!Describable categoriesFor: #shortDescription!accessing!public! !
!Describable categoriesFor: #shortDescription:!accessing!public! !
!Describable categoriesFor: #shortNounPhrase!accessing!public! !
!Describable categoriesFor: #shortNounPhrase:!accessing!public! !

!Describable class methodsFor!

chooseFrom: anArrayedCollection
	"Choose a response at random from a collection of possible text strings"

	| randomValue randomNumber |

	randomValue := self randomGenerator next.
	randomNumber := (randomValue * anArrayedCollection size) truncated + 1.
	^anArrayedCollection at: randomNumber!

randomGenerator
	RandomGenerator isNil ifTrue: [ RandomGenerator := Random new ].
	^RandomGenerator! !

!Describable class categoriesFor: #chooseFrom:!*-unclassified!public! !
!Describable class categoriesFor: #randomGenerator!*-unclassified!public! !

